function love.conf(t)
	t.title = "Slag"		-- The title of the window the game is in (string)
	t.author = "Knaimhe"		-- The author of the game (string)
	t.identity = nil			-- The name of the save directory (string)
	t.version = 8				-- The LVE version this game was made for (number)
	t.console = false			-- Attach a console (boolean, Windows only)
	t.screen.width = 1150		-- The window width (number)
	t.screen.height = 750		-- The window height (number)
	t.screen.fullscreen = false	-- Enable fullscreen (boolean)
	t.screen.vsync = true		-- Enable vertical sync (boolean)
	t.screen.fsaa = 0			-- The number of FSAA-buffers (number)
	t.modules.joystick = true	-- Enable the joystick module (boolean)
	t.modules.audio = true		-- Enable the audio module (boolean)
	t.modules.keyboard = true	-- Enable the keyboard module (boolean)
	t.modules.event = true		-- Enable the event module (boolean)
	t.modules.image = true		-- Enable the image module (boolean)
	t.modules.graphics = true	-- Enable the graphics module (boolean)
	t.modules.timer = true		-- Enable the timer module (boolean)
	t.modules.mouse = true		-- Enable the mouse module (boolean)
	t.modules.sound = true		-- Enable the sound module (boolean)
	t.modules.physics = true	-- Enable the physics module (boolean)
end

started = false
gameHUD = false
zoom = 1
camShake = 0
camShakeUpdate = 0
ssX = 0
ssY = 0
hitX = 3
hitY = 3
map = 1 --1:TestingArena

function love.load()
	love.graphics.setMode(1150, 750, false, true, 0)
	initialize()
end

function initialize()
	started = true
	gameHUD = true
	
	love.mouse.setVisible(false)
	
	world = love.physics.newWorld(0, 0, true)
	world:setAllowSleeping(true)
	world:setCallbacks(beginContact, nil, nil, nil)
	love.physics.setMeter(30)
	love.graphics.setBackgroundColor(125, 125, 125)
	
	
	Shadow = love.graphics.newImage("ShadowA.png")
	
	--Categories: 1 Walls, 2 Tanks, 3 Shots
	objects = {}
	
	pA = 0
	if map == 1 then
		pX = 500
		pY = 500
		objects.perimeter = {}
		objects.perimeter.body = love.physics.newBody(world, 0, 0, "static")
		objects.perimeter.shape = love.physics.newChainShape(true, 0, 0, 1000, 0, 1000, 1000, 0, 1000)
		objects.perimeter.fixt = love.physics.newFixture(objects.perimeter.body, objects.perimeter.shape, 0)
		objects.perimeter.fixt:setCategory(1)
		objects.perimeter.fixt:setUserData("wall")
	end
	
	--Environment Stuff
	gruntT = {}
	--Weight Variables
	hW = 1800
	eW = 600
	aW = 200
	tW = 300 --one tread, not both
	gW = 600
	--Integrity Variables
	aI = 100
	hI = 300
	ltI = 150
	rtI = 150
	gI = 100
	
	aIM = 100
	hIM = 300
	ltIM = 150
	rtIM = 150
	gIM = 100
	
	aIL = true
	hIL = true
	ltIL = true
	rtIL = true
	gIL = true
	--Movement Variables
	speed = 100
	force = 100
	--Turret Variables
	turnSpeed = 4000
	heatMax = 1000-----------------------------------------
	heat = 0
	overheated = false
	--Shield Variables
	energy = 100
	energyMax = 100
	energyRegen = 5
	--Main Weapon Variables
	sLength = 4
	sWidth = 8
	sSpeed = 1000
	reloaded = false
	reloadTime = 0.11
	reloadLevel = 0
	recoil = 25
	heatGen = 35
	accuracy = 98
	shotT = {}
	--Side Weapon Variables
	ssLength = 3
	ssWidth = 5
	ssSpeed = 1800
	sreloaded = false
	sreloadTime = 0.2
	sreloadLevel = 0
	srecoil = 5
	sheatGen = 7
	saccuracy = 96.5
	sshotT = {}
	
	objects.tank = {}
	objects.tank.b = love.physics.newBody(world, pX, pY, "dynamic")
	objects.tank.b:setLinearDamping(15)
	objects.tank.b:setAngularDamping(10)
	objects.tank.h = love.physics.newRectangleShape(0, 0, 40, 60, 0)
	objects.tank.hf = love.physics.newFixture(objects.tank.b, objects.tank.h, (hW+eW+aW)/2400)
	objects.tank.hf:setCategory(2)
	objects.tank.hf:setUserData("hull")
	objects.tank.lt = love.physics.newRectangleShape(-20, 0, 8, 50, 0)
	objects.tank.ltf = love.physics.newFixture(objects.tank.b, objects.tank.lt, tW/400)
	objects.tank.ltf:setCategory(2)
	objects.tank.ltf:setUserData("leftTread")
	objects.tank.rt = love.physics.newRectangleShape(20, 0, 8, 50, 0)
	objects.tank.rtf = love.physics.newFixture(objects.tank.b, objects.tank.rt, tW/400)
	objects.tank.rtf:setCategory(2)
	objects.tank.rtf:setUserData("rightTread")
	objects.tank.g = love.physics.newRectangleShape(0, 25, 30, 20, 0)
	objects.tank.gf = love.physics.newFixture(objects.tank.b, objects.tank.g, gW/600)
	objects.tank.gf:setCategory(2)
	objects.tank.gf:setUserData("generator")
	
	objects.tankTurret = {}
	objects.tankTurret.b = love.physics.newBody(world, pX, pY, "dynamic")
	objects.tankTurret.b:setAngularDamping(10)
	objects.tankTurret.main = love.physics.newPolygonShape(-15, -10, 0, -15, 15, -10, 15, 25, 0, 30, -15, 23)
	objects.tankTurret.mainf = love.physics.newFixture(objects.tankTurret.b, objects.tankTurret.main, 1)
	objects.tankTurret.mainf:setCategory(2)
	objects.tankTurret.mainf:setMask(1, 2, 3, 4, 5, 6, 7, 8, 9, 10)
	objects.tankTurret.bearing = love.physics.newRevoluteJoint(objects.tank.b, objects.tankTurret.b, pX, pY, false)
	objects.tankTurret.bearing:enableLimit(false)
	objects.tankTurret.barrel = love.physics.newRectangleShape(0, -30, 6, 40, 0)
	objects.tankTurret.barrelf = love.physics.newFixture(objects.tankTurret.b, objects.tankTurret.barrel, 1)
	objects.tankTurret.barrelf:setCategory(2)
	objects.tankTurret.barrelf:setMask(1, 2, 3, 4, 5, 6, 7, 8, 9, 10)
	objects.tankTurret.muzzle = love.physics.newRectangleShape(0, -50, 8, 10, 0)
	objects.tankTurret.muzzlef = love.physics.newFixture(objects.tankTurret.b, objects.tankTurret.muzzle, 0.1)
	objects.tankTurret.muzzlef:setCategory(2)
	objects.tankTurret.muzzlef:setMask(1, 2, 3, 4, 5, 6, 7, 8, 9, 10)
	objects.tankTurret.sbarrel = love.physics.newRectangleShape(10, -15, 3, 20, 0)
	objects.tankTurret.sbarrelf = love.physics.newFixture(objects.tankTurret.b, objects.tankTurret.sbarrel, 0.1)
	objects.tankTurret.sbarrelf:setCategory(2)
	objects.tankTurret.sbarrelf:setMask(1, 2, 3, 4, 5, 6, 7, 8, 9, 10)
end

function love.update(dt)
	love.graphics.setCaption("Slag by Knaimhe  FPS: "..love.timer.getFPS()..", DeltaTime: "..dt)
	if started then
		world:update(dt)
		checkTank()
		locate(dt)
		if hIL then
			aimfire(dt)
			movement(dt)
			reload(dt)
			heatcool(dt)
		end
		shield(dt)
		if not stable then
			shakeCam(dt)
		end
	end
end

function love.keypressed(key)
	if key == "up" then
		zoom = zoom+0.2
	elseif key == "down" then
		zoom = zoom-0.2
	elseif key == "right" then
		gameHUD = not gameHUD
	elseif key == "left" then
		camShake = camShake+25
	elseif key == "]" then
		accuracy = accuracy-1
		saccuracy = saccuracy-1
	elseif key == "[" then
		accuracy = accuracy+1
		saccuracy = saccuracy+1
	elseif key == ";" then
		heat = 0
	elseif key == "'" then
		camShake = 0
		stable = not stable
	elseif key == "l" then
		world:destroy()
		initialize()
	elseif key == "k" then
		takeDamage("leftTread", 25)
	elseif key == "1" then
		spawn(math.random(50, 950), 50)
	end
end

function checkTank(dt)
	if aI <= 0 then
		aI = 0
		aIL = false
	elseif aI > aIM then
		aI = aIM
	end
	if hI <= 0 then
		hI = 0
		hIL = false
		aIL = false
		ltIL = false
		rtIL = false
		gIL = false
	elseif hI > hIM then
		hI = hIM
	end
	if ltI <= 0 then
		ltI = 0
		ltIL = false
	elseif ltI > ltIM then
		ltI = ltIM
	end
	if rtI <= 0 then
		rtI = 0
		rtIL = false
	elseif rtI > rtIM then
		rtI = rtIM
	end
	if gI <= 0 then
		gI = 0
		gIL = false
	elseif gI > gIM then
		gI = gIM
	end
end

function locate(dt)
	pX, pY = objects.tank.b:getPosition()
	pA = objects.tank.b:getAngle()-math.pi/2
	tA = objects.tankTurret.b:getAngle()
	mX = love.mouse.getX()+pX-575
	mY = love.mouse.getY()+pY-375
	msX = love.mouse.getX()
	msY = love.mouse.getY()
	mD = math.sqrt((mX-pX)^2+(mY-pY)^2)
	if mX < pX then
		mA = math.atan((mY-pY)/(mX-pX))-math.pi/2
	elseif mX > pX then
		mA = math.atan((mY-pY)/(mX-pX))+math.pi/2
	end
end

function aimfire(dt)
	--objects.tankTurret.b:setAngle(mA)
	--%(math.pi*2)
	--[[if (mA+math.pi)%(math.pi*2) > (tA+math.pi)%(math.pi*2) then
		objects.tankTurret.b:applyTorque(turnSpeed) --turnright
	elseif (mA+math.pi)%(math.pi*2) < (tA+math.pi)%(math.pi*2) then
		objects.tankTurret.b:applyTorque(-turnSpeed) --turnleft
	end]]
	if love.mouse.isDown("l") then
		shootMain()
	end
	if love.mouse.isDown("r") then
		shootSide()
	end
	
	aimR = 20+camShake*2
	
	tA = (tA+math.pi)%(math.pi*2)-math.pi
	
	if mA >=0 then
		if mA > tA then
			if tA > mA-math.pi then
				objects.tankTurret.b:applyTorque(turnSpeed) --turnright
			elseif tA < mA-math.pi then
				objects.tankTurret.b:applyTorque(-turnSpeed) --turnleft
			end
		elseif mA < tA then
			objects.tankTurret.b:applyTorque(-turnSpeed) --turnleft
		end
	elseif mA < 0 then
		if mA > tA then
			objects.tankTurret.b:applyTorque(turnSpeed) --turnright
		elseif mA < tA then
			if tA > mA+math.pi then
				objects.tankTurret.b:applyTorque(turnSpeed) --turnright
			elseif tA < mA+math.pi then
				objects.tankTurret.b:applyTorque(-turnSpeed) --turnleft
			end
		end
	end
end

function movement(dt)
	speedMod = 1
	if not ltIL then
		speedMod = speedMod/2
	end
	if not rtIL then
		speedMod = speedMod/2
	end
	if love.keyboard.isDown("w") then
		objects.tank.b:applyForce(speed*force*speedMod*math.cos(pA), speed*force*speedMod*math.sin(pA))
	elseif love.keyboard.isDown("s") then
		objects.tank.b:applyForce(-speed*force*speedMod*math.cos(pA), -speed*force*speedMod*math.sin(pA))
	end
	if love.keyboard.isDown("a") then
		objects.tank.b:applyTorque(-2*speed*force*speedMod)
	elseif love.keyboard.isDown("d") then
		objects.tank.b:applyTorque(2*speed*force*speedMod)
	end
end

function shield(dt)
	if gIL then
		energy = energy+energyRegen*dt
		if energy > energyMax then
			energy = energyMax
		elseif energy < 0 then
			energy = 0
		end
	else
		energy = 0
	end
end

function reload(dt)
	reloadLevel = reloadLevel+dt
	if reloadLevel >= reloadTime then
		reloaded = true
	end
	
	sreloadLevel = sreloadLevel+dt
	if sreloadLevel >= sreloadTime then
		sreloaded = true
	end
end

function heatcool(dt)
	if heat > 0 then
		heat = heat-(10+heatMax/10)*dt
	elseif heat < 0 then
		heat = 0
	end
	if heat > heatMax then
		heat = heatMax
		overheated = true
	elseif heat < 3*heatMax/10 then
		overheated = false
	end
end

function shakeCam(dt)
	camShakeUpdate = camShakeUpdate+dt
	if camShakeUpdate > 0.05 then
		camShakeUpdate = 0
		if camShake > 0 then
			camShake = 0.75*camShake-5*dt
		end
		ssX = math.random(-camShake, camShake)
		ssY = math.random(-camShake, camShake)
	end
end

function shootMain()
	if reloaded and not overheated then
		reloaded = false
		reloadLevel = 0
		camShake = camShake+recoil
		heat = heat+heatGen
		shot = {}
		shot.b = love.physics.newBody(world, pX, pY, "dynamic")
		shot.b:setBullet(true)
		shot.s = love.physics.newRectangleShape(sLength, sWidth)
		shot.f = love.physics.newFixture(shot.b, shot.s, 1)
		shot.f:setCategory(3)
		shot.f:setMask(2)
		shot.f:setUserData("shot")
		shot.f:setSensor(true)
		shot.b:setMass(1)
		--table.insert(shotT, shot.f)
		shotT[shot.f] = shot.f
		waverA = math.pi*math.random(-1000+1000*(accuracy/100), 1000-1000*(accuracy/100))/1000
		shot.b:setAngle(tA+waverA)
		shot.b:applyLinearImpulse(sSpeed*math.cos(tA-math.pi/2+waverA), sSpeed*math.sin(tA-math.pi/2+waverA))
	end
end

function shootSide()
	if sreloaded and not overheated then
		sreloaded = false
		sreloadLevel = 0
		camShake = camShake+srecoil
		heat = heat+sheatGen
		sshot = {}
		sshot.b = love.physics.newBody(world, pX+10*math.cos(tA), pY+10*math.sin(tA), "dynamic")
		sshot.b:setBullet(true)
		sshot.s = love.physics.newRectangleShape(ssLength, ssWidth)
		sshot.f = love.physics.newFixture(sshot.b, sshot.s, 1)
		sshot.f:setCategory(3)
		sshot.f:setMask(2)
		sshot.f:setUserData("sshot")
		sshot.f:setSensor(true)
		sshot.b:setMass(1)
		table.insert(sshotT, sshot.f)
		swaverA = math.pi*math.random(-1000+1000*(saccuracy/100), 1000-1000*(saccuracy/100))/1000
		sshot.b:setAngle(tA+swaverA)
		sshot.b:applyLinearImpulse(ssSpeed*math.cos(tA-math.pi/2+swaverA), ssSpeed*math.sin(tA-math.pi/2+swaverA))
	end
end

function hitShot(hitF, shotType)
	if shotType == "main" then
		hitX, hitY = hitF:getBody():getPosition()
		--table.remove(shotT, searchTable(shotT, hitF))
		shotT[searchTable(shotT, hitF)] = nil
		hitF:getBody():destroy()
		hitF:destroy()
	elseif shotType == "side" then
		table.remove(sshotT, searchTable(sshotT, hitF))
		hitF:getBody():destroy()
		hitF:destroy()
	end
end

function searchTable(targetTable, targetElement)
	for k,v in pairs(targetTable) do
		if targetTable[k] == targetElement then
			return k
		end
	end
end

function takeDamage(part, damage)
	energy = energy-damage
	damage = damage*(1-energy/energyMax)
	if aIL then
		aI = aI-damage
	else
		if part == "hull" then
			hI = hI-damage
		elseif part == "leftTread" then
			if ltIL then
				ltI = ltI-damage
			else
				hI = hI-damage
			end
		elseif part == "rightTread" then
			if rtIL then
				rtI = rtI-damage
			else
				hI = hI-damage
			end
		elseif part == "generator" then
			if gIL then
				gI = gtI-damage
			else
				hI = hI-damage
			end
		end
	end
end

function spawn(x, y)
	
end

heatHUDX = 40
heatHUDY = 10
heatFlash = 1
reloadHUDX = 10
reloadHUDY = 10
integrityHUDX = 100
integrityHUDY = 300

function love.draw()
	if started then
		--Dynamic Camera (Drawn to Absolute/World Coordinates)
		love.graphics.scale(zoom, zoom)
		love.graphics.translate((-pX*2-mX*3)/5+575/zoom+ssX, (-pY*2-mY*3)/5+375/zoom+ssY)
		
		love.graphics.setColor(250, 250, 250)
		love.graphics.setLine(5, "smooth")
		love.graphics.line(objects.perimeter.body:getWorldPoints(objects.perimeter.shape:getPoints()))
		
		love.graphics.setColor(225, 225, 225) --tank hull
		love.graphics.polygon("fill", objects.tank.b:getWorldPoints(objects.tank.lt:getPoints()))
		love.graphics.polygon("fill", objects.tank.b:getWorldPoints(objects.tank.rt:getPoints()))
		love.graphics.setColor(175, 175, 175)
		love.graphics.polygon("fill", objects.tank.b:getWorldPoints(objects.tank.h:getPoints()))
		love.graphics.setColor(250, 250, 250)
		love.graphics.polygon("fill", objects.tank.b:getWorldPoints(objects.tank.g:getPoints()))
		
		love.graphics.setColor(250, 250, 250) --shots
		for k,v in pairs(shotT) do --for i,v in ipairs(shotT) do
			love.graphics.polygon("fill", v:getBody():getWorldPoints(v:getShape():getPoints()))
		end
		love.graphics.setColor(200, 200, 200) --sshots
		for i,v in ipairs(sshotT) do
			love.graphics.polygon("fill", v:getBody():getWorldPoints(v:getShape():getPoints()))
		end
		
		--[[love.graphics.setLine(1, "smooth") --guidelines for accuracy
		love.graphics.setColor(250, 0, 0)
		love.graphics.line(pX, pY, pX+1000*math.cos(tA-math.pi/2-math.pi+math.pi*(accuracy/100)), pY+1000*math.sin(tA-math.pi/2-math.pi+math.pi*(accuracy/100)))
		love.graphics.setColor(0, 0, 250)
		love.graphics.line(pX, pY, pX+1000*math.cos(tA-math.pi/2+math.pi-math.pi*(accuracy/100)), pY+1000*math.sin(tA-math.pi/2+math.pi-math.pi*(accuracy/100)))
		love.graphics.setLine(0.5, "smooth")
		love.graphics.setColor(250, 250, 0)
		love.graphics.line(pX+10*math.cos(tA), pY+10*math.sin(tA), pX+1000*math.cos(tA-math.pi/2-math.pi+math.pi*(saccuracy/100))+10*math.cos(tA), pY+1000*math.sin(tA-math.pi/2-math.pi+math.pi*(saccuracy/100))+10*math.sin(tA))
		love.graphics.setColor(0, 250, 0)
		love.graphics.line(pX+10*math.cos(tA), pY+10*math.sin(tA), pX+1000*math.cos(tA-math.pi/2+math.pi-math.pi*(saccuracy/100))+10*math.cos(tA), pY+1000*math.sin(tA-math.pi/2+math.pi-math.pi*(saccuracy/100))+10*math.sin(tA))
		]]
		
		love.graphics.setColor(200, 200, 200) --tank turret
		love.graphics.polygon("fill", objects.tankTurret.b:getWorldPoints(objects.tankTurret.main:getPoints()))
		love.graphics.setColor(250, 250, 250)
		love.graphics.polygon("fill", objects.tankTurret.b:getWorldPoints(objects.tankTurret.barrel:getPoints()))
		love.graphics.setColor(175, 175, 175)
		love.graphics.polygon("fill", objects.tankTurret.b:getWorldPoints(objects.tankTurret.muzzle:getPoints()))
		love.graphics.setColor(250, 250, 250)
		love.graphics.polygon("fill", objects.tankTurret.b:getWorldPoints(objects.tankTurret.sbarrel:getPoints()))
		
		--Un-Dynamic Camera (Drawn to Relative/Screen Coordinates)
		love.graphics.translate((pX*2+mX*3)/5-575/zoom-ssX, (pY*2+mY*3)/5-375/zoom-ssY)
		love.graphics.scale(1/zoom, 1/zoom)
		
		if gameHUD then
			love.graphics.setColor(0, 0, 0)
			love.graphics.draw(Shadow, -7*250+575, -7*250+375, 0, 7, 7, 0, 0, 0, 0)
			
			love.graphics.setLine(2, "smooth")
			love.graphics.setColor(250, 250, 250)
			love.graphics.line(200, msY, 250, msY)
			love.graphics.line(900, msY, 950, msY)
			love.graphics.line(msX, 0, msX, 50)
			love.graphics.line(msX, 700, msX, 750)
			
			love.graphics.setColor(100, 100, 100)
			love.graphics.rectangle("fill", 0, 0, 200, 750)
			love.graphics.rectangle("fill", 950, 0, 200, 750)
			
			reloadP = reloadLevel/reloadTime
			if reloadP > 1 then
				reloadP = 1
			end
			love.graphics.setLine(1, "smooth") --reloadHUD main
			love.graphics.setColor(reloadP*250, reloadP*250, reloadP*250)
			love.graphics.rectangle("line", 950+reloadHUDX, 0+reloadHUDY, 20, 200)
			love.graphics.rectangle("fill", 950+reloadHUDX, 200-200*reloadP+reloadHUDY, 20, 200*reloadP)
			love.graphics.setColor(250, 250, 250)
			love.graphics.print(processSpace(math.floor(reloadP*100)).."%", 946.5+reloadHUDX, 205+reloadHUDY, 0, 0.8, 0.8, 0, 0, 0, 0)
			if not reloaded then
				love.graphics.setColor(250, 250, 250)
				love.graphics.print("RELOADING", 970+reloadHUDX, 45+reloadHUDY, math.pi/2, 1.5, 1.5, 0, 0, 0, 0)
			else
				love.graphics.setColor(0, 0, 0)
				love.graphics.print("PRIMED", 970+reloadHUDX, 60+reloadHUDY, math.pi/2, 1.5, 1.5, 0, 0, 0, 0)
			end
			
			heatP = heat/heatMax
			if heatP <= 0.5 then
				heatR = heatP*500
				heatG = 250
			elseif heatP > 0.5 then
				heatR = 250
				heatG = 250-heatP*500
			end
			if heatP > 0.91 and overheated then
				heatFlash = 1/((heatP-0.9)*100)^2
			else
				heatFlash = 1
			end
			love.graphics.setLine(heatFlash, "smooth") --heatHUD
			love.graphics.setColor(heatR, heatG, 0)
			love.graphics.rectangle("line", 950+heatHUDX, 0+heatHUDY, 20, 200)
			love.graphics.rectangle("fill", 955+heatHUDX, 200-200*heatP+heatHUDY, 10, 200*heatP)
			love.graphics.line(950+heatHUDX, 140+heatHUDY, 970+heatHUDX, 140+heatHUDY)
			--love.graphics.setColor(heatR/2+125, heatG/2+125, 0)
			love.graphics.print(processSpace(math.ceil(heatP*100)).."%", 946.5+heatHUDX, 205+heatHUDY, 0, 0.8, 0.8, 0, 0, 0, 0)
			if not overheated then
				love.graphics.setColor(250, 250, 250)
				love.graphics.print("HEAT LEVEL", 970+heatHUDX, 15+heatHUDY, math.pi/2, 1.5, 1.5, 0, 0, 0, 0)
			else
				love.graphics.setColor(0, 0, 0)
				love.graphics.print("OVERHEATED", 970+heatHUDX, 10+heatHUDY, math.pi/2, 1.5, 1.5, 0, 0, 0, 0)
			end
			
			love.graphics.setLine(3, "smooth") --integrityHUD
			love.graphics.setColor(findColor(aI/aIM))
			love.graphics.rectangle("line", -54+integrityHUDX, -74+integrityHUDY, 108, 148) --armor
			love.graphics.print(processSpace(math.floor(aI+0.5)), -11+integrityHUDX, -90+integrityHUDY, 0, 1, 1, 0, 0, 0, 0)
			love.graphics.setColor(findColor(hI/hIM))
			love.graphics.rectangle("line", -40+integrityHUDX, -60+integrityHUDY, 80, 120) --hull
			love.graphics.print(processSpace(math.floor(hI+0.5)), -11+integrityHUDX, -10+integrityHUDY, 0, 1, 1, 0, 0, 0, 0)
			love.graphics.setColor(findColor(ltI/ltIM))
			love.graphics.setLine(1, "smooth")
			love.graphics.rectangle("line", -40-8+integrityHUDX, -50+integrityHUDY, 16, 100) --left tread
			love.graphics.print(processSpace(math.floor(ltI+0.5)), -82+integrityHUDX, -10+integrityHUDY, 0, 1, 1, 0, 0, 0, 0)
			love.graphics.setColor(findColor(rtI/rtIM))
			love.graphics.rectangle("line", 40-8+integrityHUDX, -50+integrityHUDY, 16, 100) --right tread
			love.graphics.print(processSpace(math.floor(rtI+0.5)), 58+integrityHUDX, -10+integrityHUDY, 0, 1, 1, 0, 0, 0, 0)
			love.graphics.setColor(findColor(gI/gIM))
			love.graphics.rectangle("line", -28+integrityHUDX, -20+50+integrityHUDY, 56, 40) --generator
			love.graphics.print(processSpace(math.floor(gI+0.5)), -11+integrityHUDX, 40+integrityHUDY, 0, 1, 1, 0, 0, 0, 0)
			
			love.graphics.setLine(1+4*energy/energyMax, "smooth") --shieldHUD
			love.graphics.setColor(100, 100+150*energy/energyMax, 100+150*energy/energyMax)
			love.graphics.circle("line", integrityHUDX, integrityHUDY, 95)
			love.graphics.setLine(1, "smooth")
			love.graphics.setColor(100, 100+150*energy/energyMax, 100+150*energy/energyMax)
			love.graphics.rectangle("fill", -90+integrityHUDX, 120+integrityHUDY, 180*energy/energyMax, 10)
			love.graphics.setColor(100, 250, 250)
			love.graphics.rectangle("line", -90+integrityHUDX, 120+integrityHUDY, 180, 10)
			love.graphics.print("Shield Power: "..processSpace(math.floor(energy+0.5)).." ("..math.floor(100*energy/energyMax+0.5).."%)", -90+integrityHUDX, 105+integrityHUDY, 0, 1, 1, 0, 0, 0, 0)
		end
		
		love.graphics.setColor(250, 250, 250)
		outputY = 10
		love.graphics.print("zoom: "..zoom, 10, outputY, 0, 1, 1, 0, 0, 0, 0)
		outputY = outputY+15
		love.graphics.print("mA: "..math.floor(mA*100+0.5)/100, 10, outputY, 0, 1, 1, 0, 0, 0, 0)
		outputY = outputY+15
		love.graphics.print("tA: "..math.floor(tA*100+0.5)/100, 10, outputY, 0, 1, 1, 0, 0, 0, 0)
		outputY = outputY+15
		love.graphics.print("camShake: "..math.floor(camShake*100+0.5)/100, 10, outputY, 0, 1, 1, 0, 0, 0, 0)
		outputY = outputY+15
		love.graphics.print("Main Accuracy: "..accuracy, 10, outputY, 0, 1, 1, 0, 0, 0, 0)
		outputY = outputY+15
		love.graphics.print("Side Accuracy: "..saccuracy, 10, outputY, 0, 1, 1, 0, 0, 0, 0)
		outputY = outputY+15
		love.graphics.print("HitX: "..math.floor(hitX*100+0.5)/100, 10, outputY, 0, 1, 1, 0, 0, 0, 0)
		outputY = outputY+15
		love.graphics.print("HitY: "..math.floor(hitY*100+0.5)/100, 10, outputY, 0, 1, 1, 0, 0, 0, 0)
		outputY = outputY+15
		love.graphics.print("Meter: "..love.physics.getMeter(), 10, outputY, 0, 1, 1, 0, 0, 0, 0)
		outputY = outputY+15
		
		love.graphics.setLine(3, "smooth") --cursor background
		love.graphics.setColor(0, 0, 0)
		love.graphics.circle("line", msX, msY, aimR)
		love.graphics.line(msX-5, msY-5, msX+5, msY+5)
		love.graphics.line(msX-5, msY+5, msX+5, msY-5)
		
		love.graphics.setLine(2, "smooth") --cursor
		love.graphics.setColor(250, 250, 250)
		love.graphics.circle("line", msX, msY, aimR)
		love.graphics.line(msX-5, msY-5, msX+5, msY+5)
		love.graphics.line(msX-5, msY+5, msX+5, msY-5)
	end
end

function processSpace(value)
	if value >= 100 then
		return ""..value
	elseif value >= 10 then
		return " "..value
	else
		return "  "..value
	end
end

function findColor(valueP)
	if valueP <= 0 then
		colorR = 0
		colorG = 0
	elseif valueP <= 0.5 then
		colorR = 250
		colorG = valueP*500
	elseif valueP > 0.5 then
		colorR = 250-valueP*500
		colorG = 250
	end
	return colorR, colorG, 0
end

function beginContact(aFixt, bFixt, Coll)
	a = aFixt:getUserData()
	b = bFixt:getUserData()
	if check(a, b, "wall") and check(a, b, "shot") then
		hitShot(checkItem(aFixt, bFixt, "shot"), "main")
	elseif check(a, b, "wall") and check(a, b, "sshot") then
		hitShot(checkItem(aFixt, bFixt, "sshot"), "side")
	end
end

function check(a, b, data)
	if a == data or b == data then
		return true
	else
		return false
	end
end

function checkItem(aFixt, bFixt, data)
	if aFixt:getUserData() == data then
		return aFixt
	elseif bFixt:getUserData() == data then
		return bFixt
	end
end

--[[
--!! Update Log:
11/18/12:
	Game created, screen created, zoom and dynamic camera implemented, tank created
11/20/12:
	Eureka! Most wondrous and glorious discovery of technique to rotate turret across bottom
		O frabjous day! Callooh! Callay!
		Milestones to this discovery:
			Output displaying mA, discovered mA ranges from -pi to pi
			Magnificent set of conditions allowing for proper rotation within plus or minus one rotation of initial position
			Output displaying tA, discovered tA has an infinite range
			Statement resetting value of tA to the "proper" absolute value (modified remainder of modified angle)
	Dynamic camera gets better and better:
		Now also accounts for mouse world position (pretty awesome, 2:3 tank to mouse position ratio influence on camera)
		Dyamic camera experiences shake due to weapons recoil (weapons feel more powerful, like they have weight)
	Heat system, including:
		HeatHUD (colors rotate through green at 0 to yellow at 50 and red at 100 heat)
		Overheating system (prevents firing until sufficiently cooled)
11/21/12:
	Added side weapon
	ReloadHUD
	Polar Inaccuracy
	Numerical display (%) for heat and reload HUDs
11/22/12:
	Implemented weights
	Implemented integrity, integrityHUD
	Implemented shield, shieldHUD
11/23/12:
	Implemented heatFlash... beautiful! (dat flash, dat math)
11/24/12:
	Outlined cursor

--!! Planned:
		Explosions!
		Cursor to show expected accuracy
		Actual interface, damnit!
		Self-Destruct
		Tertiary weapon, aimed w/ mouse when fire key is down, shot when fire key is released
--!! Known Problems:
		BLARRGH
		Can't get some shit workin'.
]]